<template>
  <div class="content">
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <vue-confirm-dialog></vue-confirm-dialog>
    <div style="margin-top: 50px;">
      <span style="font-size: 18px;"
        ><a href="#/dashboard/report-mata-kuliah-kota" style="color: grey"
          >Daftar Mata Kuliah
        </a></span
      >
      <span style="font-size: 17px; padding: 0px 5px"> > </span>
      <span style="font-size: 18px">Manage Periode</span>
    </div>
    <form ref="form" novalidate class="md-layout" @submit.prevent="onSubmit">
      <md-card
        class="md-layout-item md-size-95 md-small-size-100"
        style="padding: 0px 20px 30px 20px; margin-left: 30px"
      >
        <md-card-header>
          <div class="md-title">
            <h2 style="letter-spacing: 2px;color: green;margin-top:30px;">
              <strong>Tambah Periode</strong>
            </h2>
          </div>
        </md-card-header>

        <md-card-content>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('tahun')">
                <label for="tahun">Tahun Akademik...</label>
                <md-input
                  name="tahun"
                  id="tahun"
                  v-model="periodeData.tahun"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span class="md-error" v-if="!$v.periodeData.tahun.required"
                  >Tahun Akademik is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('semester')">
                <label for="semester">Semester...</label>
                <md-select
                  name="semester"
                  id="semester"
                  v-model="periodeData.semester"
                  md-dense
                  :disabled="sending"
                >
                  <md-option value="1" style="width:100%; left: 10px;">
                    01 - Ganjil
                  </md-option>
                  <md-option value="2" style="width:100%; left: 10px;">
                    02 - Genap
                  </md-option>
                </md-select>
                <span class="md-error" v-if="!$v.periodeData.semester.required"
                  >Semester is required</span
                >
              </md-field>
            </div>
          </div>
        </md-card-content>

        <md-card-actions style="padding-top: 50px">
          <md-button
            type="submit"
            class="md-login md-success md-lg md-round"
            :disabled="sending"
            style="height: 50px; width: 140px"
            ><span
              style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
            >
              Submit
            </span>
          </md-button>
        </md-card-actions>

        <md-progress-bar md-mode="indeterminate" v-if="sending1" />
      </md-card>

      <md-snackbar :md-active.sync="userSaved"
        >Periode Berhasil Ditambahkan!</md-snackbar
      >
    </form>
    <md-table
      v-model="periodeList"
      md-sort="name"
      md-sort-order="asc"
      style="padding: 50px 5px 10px 30px; border-radius: 20px;"
      md-card
      md-fixed-header
    >
      <md-table-row slot="md-table-row" slot-scope="{ item }">
        <md-table-cell md-label="Tahun" md-sort-by="tahun">
          {{ item.tahun }}
        </md-table-cell>
        <md-table-cell md-label="Semester" md-sort-by="semester">
          <div v-if="item.semester == '01' || item.semester == '1'">
            01 - Ganjil
          </div>
          <div v-if="item.semester == '02' || item.semester == '2'">
            02 - Genap
          </div>
        </md-table-cell>
        <md-table-cell>
          <router-link
            :to="{
              name: 'periode-update',
              params: { id: item.id }
            }"
          >
            <i
              class="fa fa-edit"
              aria-hidden="true"
              style="
                color: #0b76e0;
                font-size: 18px;
              "
              ><md-tooltip md-direction="bottom">Update Periode</md-tooltip></i
            >
          </router-link>
        </md-table-cell>
        <md-table-cell>
          <md-button
            type="submit"
            class="md-simple md-danger"
            style="height: 20px;"
            @click="onDelete(item.id)"
          >
            <i
              class="fa fa-times"
              aria-hidden="true"
              style="font-size: 20px !important"
              ><md-tooltip md-direction="bottom">Delete Periode</md-tooltip></i
            >
          </md-button>
        </md-table-cell>
      </md-table-row>
    </md-table>
    <md-progress-bar md-mode="indeterminate" v-if="sending2" />

    <md-snackbar :md-active.sync="userSaved"
      >Proses menghapus berhasil</md-snackbar
    >
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    form: {
      tahun: null,
      semester: null
    },
    userSaved: false,
    sending1: false,
    sending2: false
  }),
  validations: {
    periodeData: {
      tahun: {
        required
      },
      semester: {
        required
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("periode", ["periodeData", "periodeList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    }
  },
  methods: {
    ...mapActions("periode", [
      "createPeriode",
      "getPeriodeList",
      "deletePeriode"
    ]),
    async onFetchData() {
      await this.getPeriodeList();
    },
    async onSubmit() {
      this.$v.$touch();
      this.sending1 = true;
      if (!this.$v.invalid) {
        try {
          await this.createPeriode({
            id: this.$route.params.id,
            payload: this.periodeData
          });
          this.sending1 = false;
          this.periodeData = {};
          this.$router.push({ name: "report-mata-kuliah-kota" });
        } catch (error) {
          this.sending1 = false;
          throw Error(error);
        }
      }
    },
    onDelete(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data Periode?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deletePeriode({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending2 = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    getValidationClass(fieldName) {
      const field = this.$v.periodeData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css">
.md-progress-bar {
  margin: 24px;
}
</style>
